import base64
import json
import time

from datetime import datetime
from fischertechnik.mqtt.Client import Client as MqttClient
from fischertechnik.mqtt.Constants import CONTROLLER_ID
from lib.camera import *
from lib.controller import *


snapshot = None
ts = None


def image_callback(event):
    global snapshot, ts
    snapshot = "data:image/jpeg;base64," + base64.b64encode(event.value).decode("utf-8")

TXT_M_USB1_1_camera.add_change_listener("image", image_callback)


def datetimestamp():
    global snapshot, ts
    ts = datetime.now().strftime("%Y-%m-%dT%H:%M:%S.%f")[:-3] + "Z"
    return ts


snapshot = ''
MqttClient.getInstance().connect()
while True:
    if (MqttClient.getInstance().is_connected()):
        break
    time.sleep(0.010)
while True:
    MqttClient.getInstance().publish("/j1/txt/" + str(CONTROLLER_ID) +"/i/cam", '{{"ts":"{}","data":"{}"}}'.format(datetimestamp(), snapshot))
    time.sleep(1)


